USE [StackOverflow2010]
GO

-- Create Users Array with nested JSON objects
DECLARE @json1 NVARCHAR(512) = N'
{"Users":[
	{ 
	"Id":-1,
	"DisplayName":"Community",
	"Activity":{
		"Reputation":1,
		"Views":649,
		"UpVotes":225495,
		"DownVotes":890820
		},
	"LastAccessDate":"2008-08-26 00:16:53.810"
	},
	{ 
	"Id":25,
	"DisplayName":"CodingWithoutComments",
	"Activity":{
		"Reputation":15587,
		"Views":3618,
		"UpVotes":537,
		"DownVotes":83
		},
	"LastAccessDate":"2017-11-22 05:03:39.410"
	}
   ]
}';

/*
Specify values to return and column names/types using the WITH clause;
*/
SELECT *
FROM OPENJSON(@json1, N'$.Users')
WITH([Id] INT, [DisplayName] NVARCHAR(25),[LastAccessDate] DATETIME);


/*
Add items from "Activity" object to query results;
*/
DECLARE @json2 NVARCHAR(512) = N'{"Users":[{"Id":-1,"DisplayName":"Community","Activity":{"Reputation":1,	"Views":649,"UpVotes":225495,"DownVotes":890820},"LastAccessDate":"2008-08-26 00:16:53.810"},{"Id":25,"DisplayName":"CodingWithoutComments","Activity":{"Reputation":15587,"Views":3618,"UpVotes":537,"DownVotes":83},"LastAccessDate":"2017-11-22 05:03:39.410"} ]}';

SELECT *
FROM OPENJSON(@json2, N'$.Users')
WITH([Id] INT, [DisplayName] NVARCHAR(25),[LastAccessDate] DATETIME, 
	[Reputation] INT N'$.Activity.Reputation', 
	[Views] INT N'$.Activity.Views', 
	[UpVotes] INT N'$.Activity.UpVotes', 
	[DownVotes] INT N'$.Activity.DownVotes');
	
	

/*
Use AS JSON to return items from "Activity" object...wait for it...as JSON;
*/
DECLARE @json3 NVARCHAR(512) = N'{"Users":[{"Id":-1,"DisplayName":"Community","Activity":{"Reputation":1,	"Views":649,"UpVotes":225495,"DownVotes":890820},"LastAccessDate":"2008-08-26 00:16:53.810"},{"Id":25,"DisplayName":"CodingWithoutComments","Activity":{"Reputation":15587,"Views":3618,"UpVotes":537,"DownVotes":83},"LastAccessDate":"2017-11-22 05:03:39.410"} ]}';
	
SELECT *
FROM OPENJSON(@json3, N'$.Users')
WITH([Id] INT, [DisplayName] NVARCHAR(25),[LastAccessDate] DATETIME, [Activity] NVARCHAR(MAX) AS JSON);
