USE [StackOverflow2010]
GO

/*
Auto-convert Array into table of results
*/
DECLARE @IdList NVARCHAR(4000) = N'[1,2,3,4,11,23,48,199,247,1965]'

SELECT u.Id, u.DisplayName,u.CreationDate,u.LastAccessDate,u.Reputation
FROM dbo.Users u
INNER JOIN OPENJSON(@IdList) AS userList ON u.Id = userList.value


/*
Union multiple JSON objects into single query result
*/
DECLARE @json1 NVARCHAR(MAX)=N'{"firstName": "Bruce", "lastName":"Wayne"}'
		,@json2 NVARCHAR(MAX)=N'{"firstName": "Luke", "lastName":"Skywalker"}'
		,@json3 NVARCHAR(MAX)=N'{"firstName": "Homer", "lastName":"Simpson"}';

SELECT [firstName],[lastName]
FROM OPENJSON(@json1)
WITH ([firstName] NVARCHAR(25),[lastName] NVARCHAR(25))

UNION

SELECT [firstName],[lastName]
FROM OPENJSON(@json2)
WITH ([firstName] NVARCHAR(25),[lastName] NVARCHAR(25))

UNION

SELECT [firstName],[lastName]
FROM OPENJSON(@json3)
WITH ([firstName] NVARCHAR(25),[lastName] NVARCHAR(25))
