/*
JSON_MODIFY - Updates the value of a property in a JSON string and returns the updated JSON string.
https://docs.microsoft.com/en-us/sql/t-sql/functions/json-modify-transact-sql
*/

DECLARE @info NVARCHAR(100)=N'{"name":"John","skills":["C#","SQL"]}'
SELECT [ORIGINAL] = @info

-- Update name  
SET @info=JSON_MODIFY(@info,N'$.name','Mike')
SELECT [UPDATE] = @info
GO


DECLARE @info NVARCHAR(100)=N'{"name":"John","skills":["C#","SQL"]}'
SELECT [ORIGINAL] = @info

-- Insert lastname  
SET @info=JSON_MODIFY(@info,N'$.lastname','Smith')
SELECT [INSERT] = @info
GO


DECLARE @info NVARCHAR(100)=N'{"name":"John","skills":["C#","SQL"]}'
SELECT [ORIGINAL] = @info

-- Delete name  
SET @info=JSON_MODIFY(@info,N'$.name',NULL)
SELECT [DELETE] = @info
GO


DECLARE @info NVARCHAR(100)=N'{"name":"John","skills":["C#","SQL"]}'
SELECT [ORIGINAL] = @info

-- Add skill  
SET @info=JSON_MODIFY(@info,N'append $.skills','Azure')
SELECT [APPEND] = @info
GO


/*Put it all on one line*/
DECLARE @info NVARCHAR(100)=N'{"name":"John","skills":["C#","SQL"]}';
SELECT @info;

-- Multiple JSON_MODIFY function calls  
SET @info=JSON_MODIFY(JSON_MODIFY(JSON_MODIFY(@info,N'$.name',N'Mike'),N'$.lastname',N'Smith'),N'append $.skills',N'Azure');
SELECT @info;
GO