/*
Storing JSON in a table
*/
DROP TABLE IF EXISTS #PizzaOrders;

CREATE TABLE #PizzaOrders (
    [ID] INT PRIMARY KEY IDENTITY,
    [Order] NVARCHAR(512)--must use NVARCHAR datatype
);


DECLARE @json NVARCHAR(512) = N'{
	"FirstName":"Homer",
	"LastName":"Simpson",
	"Size":"Large",
	"Crust":"Thin",
	"Toppings":["Sausage","Mushrooms","Peppers"],
	"Cost":17.95
}';
--insert JSON object into the temp table
INSERT INTO #PizzaOrders ([Order])
VALUES (@json);


SELECT * FROM #PizzaOrders;

--Parse JSON and return as regular query result
SELECT [FirstName] = JSON_VALUE([Order],'$.FirstName')
	,[LastName] = JSON_VALUE([Order],'$.LastName')
	,[Size] = JSON_VALUE([Order],'$.Size')
	,[Crust] = JSON_VALUE([Order],'$.Crust')
	,[Cost] = JSON_VALUE([Order],'$.Cost')
	,[Toppings] = JSON_QUERY([Order],'$.Toppings')
FROM #PizzaOrders

-- return key/value pairs of the JSON in the table
SELECT [key], [value] FROM OPENJSON((SELECT TOP 1 [Order] FROM #PizzaOrders));

--Parse JSON and return as regular query result
SELECT * FROM OPENJSON((SELECT TOP 1 [Order] FROM #PizzaOrders))
WITH([FirstName] NVARCHAR(25),[LastName] NVARCHAR(25),[Size] NVARCHAR(25), [Crust] NVARCHAR(25), [Cost] FLOAT, [Toppings] NVARCHAR(MAX) AS JSON);



